--
-- complexBGA
--
-- upsideDown project start: 01.06.2014
-- restart from scrap: 26.8.2014
-- 
-- V0.9Beta: 1.9.2014: All intended features implemented, SP only!
-- V0.91Beta: 2.9.2014: MP added
-- V1.0 initial release, 5.9.2014
-- V1.1 6.9.2014: save bug removed, made readout for MapBuyableObject, correction of LM-trigger collisionMask (Holzhausen, Herrenhausen map etc)
-- V2.0 19.9.2014: biogas residues, liquid substrates, manure-bonus system, choosing buy size with new prices, handle from tipTrigger, added forgotten potatos, handling from vehicles in LM-Triggers allowed, collision correction removed, 
-- V2.1 load problems with large installations removed, liquids are now added correctly to fermenter, adding liquid substrates now works with empty residue storage
-- V3.0 6.11.2014: conversion to LS15, feeding system now shows speed control
-- V3.01: 8.11.2014: bugfix for buy-sync on dedi
-- V3.02: 8.06.2015: bugfix for bonus biomass into tiptrigger
-- V3.03 compatibility patch for LS15_1.3, fix for MP problems with liquid manure
-- V4.00 converted to LS17. Removed biogasresidue hacks, now using digestate

g_i18n.globalI18N.texts["complexBGA_BioGasResiduesTool"]    = g_i18n:getText("complexBGA_BioGasResiduesTool");
g_i18n.globalI18N.texts["complexBGA_liquidSubstrateIntoBGA"]    = g_i18n:getText("complexBGA_liquidSubstrateIntoBGA");

Bga.complexBgaDebug = false; --dont touch this unless you really know what you are doing...

complexBGA = {};
addModEventListener(complexBGA);

function complexBGA:loadMap(name)
	print("--- loading complexBGA mod V4.00 --- (by upsidedown)")

	Bga.addBGAfillType(FillUtil.FILLTYPE_SILAGE,0.3,202*0.52,1.0,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_MANURE,0.25,45*0.60,0.75,false,false,true)
	
	Bga.addBGAfillType(FillUtil.FILLTYPE_DRYGRASS,0.35,172*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_DRYGRASS_WINDROW,0.35,172*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_SUGARBEET,0.23,111*0.51,1.2,false,false,false)
	
	
	--Bga.addBGAfillType("hay",0.87,324*0.67,0.95,false,false,false)
	
	Bga.addBGAfillType(FillUtil.FILLTYPE_WHEAT,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_BARLEY,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_RAPE,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_OAT,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_RYE,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_MILLET,0.88,490*0.54,0.9,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_DINKEL,0.88,490*0.54,0.9,false,false,false)
	
	--new in V2.0
	Bga.addBGAfillType(FillUtil.FILLTYPE_POTATO,0.22,151*0.52,1.2,false,false,false)
	Bga.addBGAfillType(FillUtil.FILLTYPE_LIQUIDMANURE,0.10,30*0.55,0.85,false,true,true)
	
	
	Bga.noComplexBgaBuyNeeded = false;	
			
end;

function complexBGA:deleteMap()
end


function complexBGA:mouseEvent(posX, posY, isDown, isUp, button)
end;

function complexBGA:keyEvent(unicode, sym, modifier, isDown)
end;


function complexBGA:update(dt)
	
end


function complexBGA:draw()   
end;

function Bga.addBGAfillType(fillType,TS,quality,speedFx,force,isLiquid,isBonus)
	if Bga.complexBGA_data == nil then
		Bga.complexBGA_data = {};
	end;
	
	if fillType ~= nil then
		if Bga.complexBGA_data[fillType] == nil or force then
			Bga.complexBGA_data[fillType] = {};
			Bga.complexBGA_data[fillType].TS = TS;
			Bga.complexBGA_data[fillType].quality = quality/TS; 
			Bga.complexBGA_data[fillType].speedFx = speedFx;
			Bga.complexBGA_data[fillType].isLiquid = isLiquid;
			Bga.complexBGA_data[fillType].isBonus = isBonus;
		end;
	end;	
end;


local oldBGAload = Bga.load;
function Bga:load(nodeId)
	local res = oldBGAload(self,nodeId);
	self.fermenterCapacity = 1000*1250; --*self.bunkerUseSpeed/25; --25 is standard, is set equal to 500kW_el installation
	
	
	if self.digestateSiloTrigger~= nil then
		self.digestateSiloTrigger.capacity = 800000
	end;
	
	
	self.fermenterTS = 0.0; 
	self.fermenter_quality = 0;   --fermenter in empty mode
	self.fermenter_speedFx = 1.0;
		
	self.bunkerUseSpeed = 4.75; --self.bunkerUseSpeed * self.bunkerUseSpeed/75*0.57*1.0;
	--self.bunkerCapacity
	--print("bunkerUseSpeed: ",self.bunkerUseSpeed)
	
	self.bunker_quality = 202*0.52/0.3;   -- bunker filled with maize silage
	self.bunker_TS = 0.30;
	self.bunker_speed = 1.0;
	

	
	self.bunkerFeedFactor = 1.0;
	
	self.fermenter_TS_min = 0.04;
	self.fermenter_TS_opt = 0.10;
	self.fermenter_TS_clog = 0.16;
	
	self.fermenter_bioOK = false; --default off
	

	if self.digestateSiloTrigger ~= nil then
		self.digestateSiloTrigger.bga = self; 		
	end;
	
	self.printPower = 0;
	self.initialSyncDone = false;
	
	--self.BGA_Bonus_Capacity = 3*120 * g_liquidManureLitersPerAnimalPerDay["cow"];
	self.BGA_Bonus_Capacity = 3*120 * 250; --TODO LATER
	self.BGA_Bonus = 0;
	
	self.BGA_sizeFx = 1.0;
	
	self.tipTriggers2BGAdataInitDone = false;
	
	self.moneyPrintSum = 0;
	self.moneyPrintLastHour = 0;
	
	

		
	return res;
end;

function Bga.fillHours()	
	return math.abs(g_currentMission.environment.currentHour - 8) < 0.5 or math.abs(g_currentMission.environment.currentHour - 20) < 0.5;	
end


	local DebugTime = 0; --DEBUG
	local DebugMoney = 0;
	local DebugMoneyFromPrice = 0;
	local DebugLastFeed = 0;


function Bga:updateTick(dt)
	DebugTime = DebugTime+dt/1000*g_currentMission.loadingScreen.missionInfo.timeScale;
    if self.isServer then
			if not self.initialSyncDone then
				BGAsyncEvent.sendEvent(self)
				self.initialSyncDone = true;
			end;
			
			self.bunkerUseTime = self.bunkerUseTime + dt;

			local timestep = 1000;
			if g_currentMission.loadingScreen.missionInfo.timeScale > 50 then
				timestep = timestep*0.5;
			end;
			if g_currentMission.loadingScreen.missionInfo.timeScale > 100 then
				timestep = timestep*0.5;
			end;
			if g_currentMission.loadingScreen.missionInfo.timeScale > 120 then --run on dt if "fastForward" is used
				timestep = 0;
			end;			
			if self.fermenter_bioOK then
				if self.bunkerUseTime > timestep then					
					if Bga.fillHours() then --feed twice a day					
						if self.bunkerFillLevel > 0 and (self.digestateSiloTrigger == nil or self.digestateSiloTrigger.fillLevel < self.digestateSiloTrigger.capacity) then 							
							local oldFillLevel = self.bunkerFillLevel;

							local bunkerUseSpeed = self.bunkerUseSpeed*g_currentMission.loadingScreen.missionInfo.timeScale--/self.bunkerUseTime;
							
							local m_add = self.bunkerUseTime/1000 * bunkerUseSpeed * 0.35/self.bunker_TS; --normed to maize silage;
							
							m_add = m_add*self.bunkerFeedFactor;
							
							--self:setBunkerFillLevel(self.bunkerFillLevel - m_add);
							self:setFillLevel(self.bunkerFillLevel - m_add);

							local delta = oldFillLevel-self.bunkerFillLevel;
							
							if delta > 0 and self.digestateSiloTrigger ~= nil then
								local feed2manure = (1-self.bunker_TS)/(1-self.fermenterTS)
								self.digestateSiloTrigger:setFillLevel(self.digestateSiloTrigger.fillLevel + delta*feed2manure);
							end;
							
							if delta > 0 then
								self.fermenterTS = ((self.fermenterCapacity-delta)*self.fermenterTS + delta*self.bunker_TS)/self.fermenterCapacity;
								self.fermenter_quality = ((self.fermenterCapacity-delta)*self.fermenter_quality + delta*self.bunker_quality)/self.fermenterCapacity;
								self.fermenter_speedFx = ((self.fermenterCapacity-delta)*self.fermenter_speedFx + delta*self.bunker_speed)/self.fermenterCapacity;
							end;							
						end;
					elseif Bga.complexBgaDebug then --DEBUG FEEDING
						if g_currentMission.controlPlayer then --DEBUG ONLY!!!
							
							local delta = math.max(self.bunkerCapacity - self.bunkerFillLevel,0)
							
							-- local difficultyMultiplier = math.max(2 * (3 - g_currentMission.loadingScreen.missionInfo.difficulty), 1)
							local difficultyMultiplier = g_currentMission.missionInfo.sellPriceMultiplier;
							
							local money = FillUtil.fillTypeIndexToDesc[FillUtil.FILLTYPE_SILAGE].pricePerLiter * difficultyMultiplier * delta
							DebugMoneyFromPrice = DebugMoneyFromPrice + money;
							
							self.bunkerFillLevel = self.bunkerFillLevel + delta;
							
							self.digestateSiloTrigger.fillLevel = math.min(self.digestateSiloTrigger.capacity/2,self.digestateSiloTrigger.fillLevel);
							
							DebugLastFeed = delta;
						end;
					end;
					
					--- end feeding
					
					--start digesting:
					local k = 0.0025/3600/24*75; --s^-1
													
					local f_TS = 0.0; 
										
					if self.fermenterTS > self.fermenter_TS_min and self.fermenterTS <= self.fermenter_TS_opt then
						f_TS = (self.fermenterTS - self.fermenter_TS_min)^2/(self.fermenter_TS_opt-self.fermenter_TS_clog)^2
					elseif self.fermenterTS > self.fermenter_TS_opt then
						f_TS = 1.0;
					end; --clogging comes later (if ever)
					
					local dTS = self.fermenterTS^1.5 * f_TS * k * self.fermenter_speedFx;
					
										
					dTS = dTS * self.bunkerUseTime/1000*g_currentMission.loadingScreen.missionInfo.timeScale;
					self.fermenterTS = self.fermenterTS - dTS;
					
					local m_gas = dTS*self.fermenterCapacity/1000*self.fermenter_quality;
					
					self.printPower = m_gas/(g_currentMission.loadingScreen.missionInfo.timeScale*self.bunkerUseTime/1000)*3600*40/2.5/3;
					
					dBonus = self.BGA_Bonus_Capacity/(3*24*3600*1000)*g_currentMission.loadingScreen.missionInfo.timeScale;
					self.BGA_Bonus = math.max(0,self.BGA_Bonus - dBonus*self.bunkerUseTime);

					local bonusMultiplier = 1.0;
					if self.BGA_Bonus > 0.1 and self.BGA_sizeFx<1.05 then --manure bonus only for small installations!
						bonusMultiplier = bonusMultiplier*1.25;
					end;
					
					if self.BGA_sizeFx > 1.02 then
						bonusMultiplier = bonusMultiplier*0.9; --10% less for large installations (german EEG rules, sry ;))
					end;
					
					
					
					-- toDo: Make beautiful :) 
					 
					-- local difficultyMultiplier = math.max(2 * (3 - g_currentMission.loadingScreen.missionInfo.difficulty), 1)
					local difficultyMultiplier = g_currentMission.missionInfo.sellPriceMultiplier;
					local money = m_gas*35*FillUtil.fillTypeIndexToDesc[FillUtil.FILLTYPE_SILAGE].pricePerLiter;
					money = money*difficultyMultiplier*bonusMultiplier;

					g_currentMission:addSharedMoney(money, "incomeBga")

					self.moneyPrintSum = self.moneyPrintSum + money;
					-- self.moneyPrintLastHour = 0;
					if g_currentMission.environment.currentHour ~= self.moneyPrintLastHour then
						 -- g_currentMission:addMoneyChange(self.moneyPrintSum, FSBaseMission.MONEY_TYPE_SINGLE, true, g_i18n:getText("finance_soldBales"));
						 g_currentMission:addMoneyChange(self.moneyPrintSum, FSBaseMission.MONEY_TYPE_SINGLE, true, "BGA");
						self.moneyPrintSum = 0;
						self.moneyPrintLastHour = g_currentMission.environment.currentHour;
					end;
	
					
					local dayCost = g_currentMission.loadingScreen.missionInfo.difficulty*1000*(1 + math.max(self.fermenterTS-0.1,0)*10);
					local cost = dayCost/24/3600/1000*self.bunkerUseTime;
					
					g_currentMission:addSharedMoney(-cost, "propertyMaintenance");			
					
					if self.fermenterTS < 0.05 then
						self.fermenter_bioOK = false;
						self.printPower = 0;
					end;

					if Bga.complexBgaDebug then
						DebugMoney = DebugMoney + money - cost;
						print(DebugTime," ",DebugMoney," "..tostring(DebugMoneyFromPrice).." "..tostring(DebugLastFeed))
					end;
									
					self.bunkerUseTime = 0;
					
					BGAsyncEvent.sendEvent(self)
					
				end;			
			end;
		if self.bunkerFillLevel ~= self.sentBunkerFillLevel then
			self:raiseDirtyFlags(self.bgaDirtyFlag);

			self.sentBunkerFillLevel = self.bunkerFillLevel;
		end;
    end;
end;

function returnZero(x)
	return 0
end;


local oldBGA_update = Bga.update;

function Bga:update(dt)
	
	if not self.tipTriggers2BGAdataInitDone then
		self.tipTriggers2BGAdataInitDone = true;
		for k,tipTrigger in pairs(self.tipTriggers) do
			local allowedToolTypes = {TipTrigger.TOOL_TYPE_TRAILER, TipTrigger.TOOL_TYPE_SHOVEL, TipTrigger.TOOL_TYPE_PIPE};
			for fillType,_ in pairs(Bga.complexBGA_data) do
				tipTrigger:addAcceptedFillType(fillType, 1, false, true, allowedToolTypes);
			end
			tipTrigger:initPricingDynamics();
			tipTrigger.bga = self;
			tipTrigger.getEffectiveFillTypePrice = returnZero;
		end
	end
	
	
	
	--oldBGA_update(self,dt);
	
	if self.isClient then --replacement of deactivated code below
		self.checkTriggers = true;
		if g_currentMission.controlPlayer and g_currentMission.player ~= nil then		
			if self.checkTriggers then
				local px,py,pz = getWorldTranslation(g_currentMission.player.rootNode);
				
				for k,trigger in pairs(self.tipTriggers) do
					local x, y, z = getWorldTranslation(trigger.rootNode);
					local distance =  Utils.vector3Length(px-x, py-y, pz-z);
					if distance < 7.5 then
						Bga.handleInput(self);
						break;
					end;
				end;
			end;
		end;
	end;
	
	if self.isClient then --adapted copy of original LS17 update function		
		
		if Bga.fillHours() then
			oldBGA_update(self,dt);				
		else
			if self.digestateSiloTrigger ~= nil then
				self.digestateSiloTrigger:update(dt);
			end
			if self.bunkerSoundPlaying then
				setVisibility(self.bunkerSoundId, false);
				self.bunkerSoundPlaying = false;
			end;
		end;		
	end;

	if false then
		renderText(0.4,0.3,0.02,"Fermenter: TS: "..tostring(self.fermenterTS).."  quality: "..tostring(self.fermenter_quality).."  speed: "..tostring(self.fermenter_speedFx))
		renderText(0.4,0.34,0.02,"Bunker: fillLevel: "..tostring(self.bunkerFillLevel).."  TS: "..tostring(self.bunker_TS).."  quality: "..tostring(self.bunker_quality).."speed: "..tostring(self.bunker_speed))
	end
end




local oldBGAgetSave = Bga.getSaveAttributesAndNodes;
function Bga:getSaveAttributesAndNodes(nodeIdent)
	local attributes, nodes = oldBGAgetSave(self,nodeIdent);
	
	attributes = attributes.. " fermenterTS=\"" ..tostring(self.fermenterTS) 
	attributes = attributes.. "\" fermenterQuality=\"" ..tostring(self.fermenter_quality)
	attributes = attributes.. "\" fermenterSpeed=\"" ..tostring(self.fermenter_speedFx)
		
	attributes = attributes.. "\" bunkerTS=\"" ..tostring(self.bunker_TS)
	attributes = attributes.. "\" bunkerQuality=\"" ..tostring(self.bunker_quality)
	attributes = attributes.. "\" bunkerSpeed=\"" ..tostring(self.bunker_speed)
	attributes = attributes.. "\" bunkerFeedFx=\"" ..tostring(self.bunkerFeedFactor)
	
	attributes = attributes.. "\" fermenter_bioOK=\"" ..tostring(self.fermenter_bioOK) 
	
	
	attributes = attributes.. "\" BGA_Bonus=\"" ..tostring(self.BGA_Bonus) 
	attributes = attributes.. "\" BGA_sizeFx=\"" ..tostring(self.BGA_sizeFx) 
	
	attributes = attributes .."\""
		
	return attributes, nodes
end;

local oldBGAloadFrom = Bga.loadFromAttributesAndNodes;
function Bga:loadFromAttributesAndNodes(xmlFile, key)	
	
	
	if true then
		local fermenterTS = getXMLFloat(xmlFile, key .. "#fermenterTS")
	    if fermenterTS ~= nil then
			self.fermenterTS = fermenterTS;
	    end
				
		local fermenter_quality = getXMLFloat(xmlFile, key .. "#fermenterQuality")
	    if fermenter_quality ~= nil then
			self.fermenter_quality = fermenter_quality;
	    end
				
		local fermenter_speedFx = getXMLFloat(xmlFile, key .. "#fermenterSpeed")
	    if fermenter_speedFx ~= nil then
			self.fermenter_speedFx = fermenter_speedFx;
	    end
				
		local bunker_TS = getXMLFloat(xmlFile, key .. "#bunkerTS")
	    if bunker_TS ~= nil then
			self.bunker_TS = bunker_TS;
	    end
				
		local bunker_quality = getXMLFloat(xmlFile, key .. "#bunkerQuality")
	    if bunker_quality ~= nil then
			self.bunker_quality = bunker_quality;
	    end
		
		local bunker_speed = getXMLFloat(xmlFile, key .. "#bunkerSpeed")
	    if bunker_speed ~= nil then
			self.bunker_speed = bunker_speed;
	    end
		
		local bunkerFeedFactor = getXMLFloat(xmlFile, key .. "#bunkerFeedFx")
	    if bunkerFeedFactor ~= nil then
			self.bunkerFeedFactor = bunkerFeedFactor;
	    end
		
		local fermenter_bioOK = getXMLBool(xmlFile, key .. "#fermenter_bioOK") --load bug fixed!
	    if fermenter_bioOK ~= nil then
			self.fermenter_bioOK = fermenter_bioOK;
	    end
		
		local BGA_Bonus = getXMLFloat(xmlFile, key .. "#BGA_Bonus") -- new in V2.0
	    if BGA_Bonus ~= nil then
			self.BGA_Bonus = BGA_Bonus;
	    end
		
		local BGA_sizeFx = getXMLFloat(xmlFile, key .. "#BGA_sizeFx") -- new in V2.0
	    if BGA_sizeFx ~= nil then
			self.BGA_sizeFx = BGA_sizeFx;
	    end
		
		self.fermenterCapacity = 1000*1250*self.BGA_sizeFx;
		self.bunkerUseSpeed = 4.75*self.BGA_sizeFx;
		self.bunkerCapacity = 30000*self.BGA_sizeFx^0.8;
		Bga.resetBunkerY(self);
		--self.BGA_Bonus_Capacity = 3*120 * g_liquidManureLitersPerAnimalPerDay["cow"]*self.BGA_sizeFx;
		self.BGA_Bonus_Capacity = 3*120 * 250 *self.BGA_sizeFx;
		--self.bunkerCapacity = math.max(self.bunkerCapacity,50000 * self.BGA_sizeFx^0.8);
		if self.digestateSiloTrigger~= nil then 
			self.digestateSiloTrigger.capacity = 800000*self.BGA_sizeFx^0.9;
		end;				
	
	end;
	
	local ok = oldBGAloadFrom(self,xmlFile, key);
	Bga.resetBunkerY(self);
	return ok;	
end;

function Bga.resetBunkerY(self)

end;

-- Bale Stuff, commented out but this is still an ongoing issue:

function Bga:objectDeleteTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay)
    if onEnter then
        -- this happens, if a compound child of a deleted compound is entering
        if otherId ~= 0 then
            local object = g_currentMission:getNodeObject(otherId);
            if object ~= nil then
                if object:isa(Bale) then
                    local difficultyMultiplier = g_currentMission.missionInfo.sellPriceMultiplier;
                    -- local value = object:getValue() * difficultyMultiplier;
                    -- g_currentMission:addSharedMoney(value, "soldBales");
                    -- g_currentMission:addMoneyChange(value, FSBaseMission.MONEY_TYPE_SINGLE, true, g_i18n:getText("finance_soldBales"));
					local allowed = false;
					for fillType,_ in pairs(Bga.complexBGA_data) do
						if fillType == object:getFillType() then
							allowed = true;
							break;
						end;
					end;					
					
					if allowed then
						if object:getFillLevel() <= self.bunkerCapacity - self.bunkerFillLevel then
							local fillType = object:getFillType();
							local fillLevel = object:getFillLevel();
							local isHay = false;
							if fillType == FillUtil.FILLTYPE_DRYGRASS_WINDROW or fillType == FillUtil.FILLTYPE_DRYGRASS then
								isHay = true;
							end;
														
							if fillType == FillUtil.FILLTYPE_SILAGE then --if its silage in bales its made from gras silage. so use it similar to gras silage from siloExtension-Mod.
								fillType = FillUtil.FILLTYPE_DRYGRASS_WINDROW;
							end;
							
							local oldFillLevel = self.bunkerFillLevel;
							self:setFillLevel(self.bunkerFillLevel + fillLevel);
							
							if Bga.complexBGA_data[fillType].isBonus then --dont know how this could be useful, but maybe someone creative will use this (bonus for IBCs with whatever...)
								self.BGA_Bonus = self.BGA_Bonus + fillLevel; --its here, for sake of completenes anyway
								self.BGA_Bonus = math.min(self.BGA_Bonus,self.BGA_Bonus_Capacity);
							end;
							
							ftData = Bga.complexBGA_data[fillType];
							if isHay then
								-- Bga.addBGAfillType("hay",0.87,324*0.67,0.95,false,false,false)
								print("is Hay!")
								ftData.TS = 0.87;
								ftData.quality = 324*0.67/ftData.TS;
								ftData.speedFx = 0.95;
								ftData.isLiquid = false;
								ftData.isBonus = false;								
							end;
							
							self.bunker_quality = (oldFillLevel*self.bunker_quality + ftData.quality*fillLevel)/self.bunkerFillLevel;
							self.bunker_TS = (oldFillLevel*self.bunker_TS + ftData.TS*fillLevel)/self.bunkerFillLevel;
							self.bunker_speed = (oldFillLevel*self.bunker_speed + ftData.speedFx*fillLevel)/self.bunkerFillLevel;							
							
							object:delete();
							
						end;
					end;
					-- self:setFillLevel(self.bunkerFillLevel + value * self.baleValueToFillDeltaScale);
                    
					
                end;
            end;
        end;
    end;
end;



-- function Bga.addBGAfillType(fillType,TS,quality,speedFx,force,isLiquid,isBonus)
	-- if Bga.complexBGA_data == nil then
		-- Bga.complexBGA_data = {};
	-- end;
	
	-- if fillType ~= nil then
		-- if Bga.complexBGA_data[fillType] == nil or force then
			-- Bga.complexBGA_data[fillType] = {};
			-- Bga.complexBGA_data[fillType].TS = TS;
			-- Bga.complexBGA_data[fillType].quality = quality/TS; 
			-- Bga.complexBGA_data[fillType].speedFx = speedFx;
			-- Bga.complexBGA_data[fillType].isLiquid = isLiquid;
			-- Bga.complexBGA_data[fillType].isBonus = isBonus;
		-- end;
	-- end;	
-- end;

-- function Bga:objectDeleteTriggerCallback(triggerId, otherId, onEnter, onLeave, onStay)
  -- if onEnter and otherId ~= 0 then
    -- local object = g_currentMission:getNodeObject(otherId)
    -- if object ~= nil and object:isa(Bale) then
				
		-- local fillLevel = object.fillLevel;
		-- local fillType = object.fillType;
		
		-- if fillLevel ~= nil and fillType~= nil then
			-- if self:getAllowShovelFillType(fillType) then
				-- if fillLevel <= self.bunkerCapacity - self.bunkerFillLevel then
			
					-- -- --> here change fillType hay stuff
					-- if fillType == FillUtil.FILLTYPE_DRYGRASS_WINDROW or fillType == FillUtil.FILLTYPE_DRYGRASS then
						-- fillType = "hay"; --dummy fillType for complexBGA_data
					-- end;
					
					-- if fillType == FillUtil.FILLTYPE_SILAGE then --if its silage in bales its made from gras silage. so use it similar to gras silage from siloExtension-Mod.
						-- fillType = FillUtil.FILLTYPE_DRYGRASS_WINDROW;
					-- end;
					
					-- local oldFillLevel = self.bunkerFillLevel;
					-- self:setBunkerFillLevel(self.bunkerFillLevel + fillLevel);
					
					-- if Bga.complexBGA_data[fillType].isBonus then --dont know how this could be useful, but maybe someone creative will use this (bonus for IBCs with whatever...)
						-- self.BGA_Bonus = self.BGA_Bonus + fillLevel; --its here, for sake of completenes anyway
						-- self.BGA_Bonus = math.min(self.BGA_Bonus,self.BGA_Bonus_Capacity);
					-- end;
					
					-- ftData = Bga.complexBGA_data[fillType];
	
					-- self.bunker_quality = (oldFillLevel*self.bunker_quality + ftData.quality*fillLevel)/self.bunkerFillLevel;
					-- self.bunker_TS = (oldFillLevel*self.bunker_TS + ftData.TS*fillLevel)/self.bunkerFillLevel;
					-- self.bunker_speed = (oldFillLevel*self.bunker_speed + ftData.speedFx*fillLevel)/self.bunkerFillLevel;
					-- object:delete()					
				-- end;
			-- end;
		-- end;		
    -- end
  -- end
-- end


-- tipTrigger.incomeName = "incomeBga";


-- for fillType_bga,entry in pairs(Bga.complexBGA_data) do		
	-- if fillType == fillType_bga then
		-- fillTypeOK = entry.isLiquid;
		-- BGAdata = entry;
		-- break;
	-- end;
-- end;

local oldTipTriggerAddFillLevelFromTool = TipTrigger.addFillLevelFromTool;

function TipTrigger:addFillLevelFromTool(object, fillDelta, fillType, toolType)
	if self.bga == nil then
		return oldTipTriggerAddFillLevelFromTool(self,object, fillDelta, fillType, toolType);
	end;
	
	
	
	local isLiquid = false;	
	if Bga.complexBGA_data[fillType] ~= nil and Bga.complexBGA_data[fillType] then
		isLiquid = Bga.complexBGA_data[fillType].isLiquid;
	else
		return 0;
	end
	
	
	local ftData = Bga.complexBGA_data[fillType];
	local oldFillLevel = self.bga.bunkerFillLevel;
	local delta = 0;
	if not isLiquid then
		delta = oldTipTriggerAddFillLevelFromTool(self,object, fillDelta, fillType, toolType);
		if Bga.complexBGA_data[fillType].isBonus then
			self.bga.BGA_Bonus = self.bga.BGA_Bonus + delta;
			self.bga.BGA_Bonus = math.min(self.bga.BGA_Bonus,self.bga.BGA_Bonus_Capacity);			
		end;

		self.bga.bunker_quality = (oldFillLevel*self.bga.bunker_quality + ftData.quality*delta)/self.bga.bunkerFillLevel;
		self.bga.bunker_TS = (oldFillLevel*self.bga.bunker_TS + ftData.TS*delta)/self.bga.bunkerFillLevel;
		self.bga.bunker_speed = (oldFillLevel*self.bga.bunker_speed + ftData.speedFx*delta)/self.bga.bunkerFillLevel;
	else
		
		local oldObjectFillLevel = object:getFillLevel(fillType);
		object:setFillLevel(oldObjectFillLevel - fillDelta, fillType, true);
		delta = object:getFillLevel(fillType) - oldObjectFillLevel;
		delta = -delta;
		if ftData.isBonus then
			self.bga.BGA_Bonus = Utils.getNoNil(self.bga.BGA_Bonus,0) + delta;							
			if self.bga.BGA_Bonus_Capacity == nil then --fix/workaround for whatever stupid errors patch 1.3 has introduced on some maps...
				-- self.bga.BGA_Bonus_Capacity = 3*120 * g_liquidManureLitersPerAnimalPerDay["cow"]*Utils.getNoNil(self.bga.BGA_sizeFx,1);
				self.bga.BGA_Bonus_Capacity = 3*120 * 250 *Utils.getNoNil(self.bga.BGA_sizeFx,1);
			end;
			self.bga.BGA_Bonus = math.min(self.bga.BGA_Bonus,self.bga.BGA_Bonus_Capacity);
		end;
		
		if delta > 0 then							
			local feed2manure = (1-ftData.TS)/(1-self.bga.fermenterTS);
			feed2manure = math.min(feed2manure,1);
			self.bga.digestateSiloTrigger:setFillLevel(self.bga.digestateSiloTrigger.fillLevel + delta*feed2manure);
		end;
		
		self.bga.fermenterTS = ((self.bga.fermenterCapacity-delta)*self.bga.fermenterTS + delta*ftData.TS)/self.bga.fermenterCapacity;
		self.bga.fermenter_quality = ((self.bga.fermenterCapacity-delta)*self.bga.fermenter_quality + delta*ftData.quality)/self.bga.fermenterCapacity;
		self.bga.fermenter_speedFx = ((self.bga.fermenterCapacity-delta)*self.bga.fermenter_speedFx + delta*ftData.speedFx)/self.bga.fermenterCapacity;
		
				
	end;
	
	return delta;
end;



function Bga.handleInput(bga)
	
	local costStartup = 120000*math.sqrt(bga.BGA_sizeFx);
	if bga.BGA_sizeFx > 1.02 then
		costStartup = costStartup + 150000;
	end;
	local costStartupBuy = 2*costStartup*bga.BGA_sizeFx^0.4;
	
	if bga.fermenter_bioOK then
	
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_bunker_FL") .. " "..tostring(math.floor(bga.bunkerFillLevel/100)/10).."m3")
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_bunker_TS") .. " "..tostring(math.floor(bga.bunker_TS*10000)/100).."%")
		
		
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_fermenter_TS") .. " "..tostring(math.floor(bga.fermenterTS*10000)/100).."%")
		
		if bga.BGA_sizeFx < 1.05 then
			g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_manureBonus") .. " "..tostring(math.floor(bga.BGA_Bonus/bga.BGA_Bonus_Capacity*10000)/100).."%")
			if bga.BGA_Bonus > 0 then
				g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_manureBonus_yes") )
			else
				g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_manureBonus_no") )
			end;
		end;
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_power") .. " "..tostring(math.floor(bga.printPower*10)/10).. " kW")
		
		
		g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_fermenter_feeding_speed")..": "..tostring(math.floor(bga.bunkerFeedFactor*100)).."%")
		if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
			g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_more_feeding"), InputBinding.BGAextension_feedUp);
			g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_less_feeding"), InputBinding.BGAextension_feedDown);
			if InputBinding.hasEvent(InputBinding.BGAextension_feedUp) then
				bga.bunkerFeedFactor = math.min(bga.bunkerFeedFactor + 0.05,1.5);
				bga.bunkerFeedFactor = math.floor(bga.bunkerFeedFactor*20+0.5)/20;
			end;
			if InputBinding.hasEvent(InputBinding.BGAextension_feedDown) then					
				bga.bunkerFeedFactor = math.max(bga.bunkerFeedFactor - 0.05,0.5);
				bga.bunkerFeedFactor = math.floor(bga.bunkerFeedFactor*20+0.5)/20;
			end;
		end;
					
	else --lets talk about buying etc
		if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
			local needBuy = bga.fermenterTS == 0 and not Bga.noComplexBgaBuyNeeded;
			
			if g_currentMission:getIsServer() or g_currentMission.isMasterUser then
				g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_buySizeUp"), InputBinding.BGAextension_feedUp);
				g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_buySizeDown"), InputBinding.BGAextension_feedDown);
				if InputBinding.hasEvent(InputBinding.BGAextension_feedUp) then
					bga.BGA_sizeFx = math.min(bga.BGA_sizeFx + 0.05,3);
				end;
				if InputBinding.hasEvent(InputBinding.BGAextension_feedDown) then					
					bga.BGA_sizeFx = math.max(bga.BGA_sizeFx - 0.05,0.5);
				end;
				
				g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_BGAsize")..": "..tostring(math.floor(bga.BGA_sizeFx*100)).."%")
				if bga.BGA_sizeFx > 1.02 then
					g_currentMission:addExtraPrintText(g_i18n:getText("complexBGA_manureBonus_2large") )
				end;
				
			end;
			
						
			if not needBuy and g_currentMission.missionStats.money >= costStartup or g_currentMission.missionStats.money >= costStartupBuy then
				if needBuy then
					g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_buyAndStartup")..": "..g_i18n:formatMoney(costStartupBuy), InputBinding.BGAextension_startup);
				else
					g_currentMission:addHelpButtonText(g_i18n:getText("complexBGA_Startup")..": "..g_i18n:formatMoney(costStartup), InputBinding.BGAextension_startup);
				end;
				if InputBinding.hasEvent(InputBinding.BGAextension_startup) then					
					bga.fermenterTS = 0.075; 
					bga.fermenter_quality = 95/0.28;
					bga.fermenter_speedFx = 0.9;
					bga.fermenter_bioOK = true;
					bga.fermenterCapacity = 1000*1250*bga.BGA_sizeFx;
					bga.bunkerUseSpeed = 4.75*bga.BGA_sizeFx;
					bga.bunkerCapacity = 30000*bga.BGA_sizeFx^0.8;
					Bga.resetBunkerY(bga);
					-- bga.BGA_Bonus_Capacity = 3*120 * g_liquidManureLitersPerAnimalPerDay["cow"]*bga.BGA_sizeFx;
					bga.BGA_Bonus_Capacity = 3*120 * 250*bga.BGA_sizeFx;
					--bga.bunkerCapacity = math.max(bga.bunkerCapacity,50000 * bga.BGA_sizeFx^0.8);
					
					if bga.digestateSiloTrigger ~= nil then
						bga.digestateSiloTrigger.capacity = 800000* bga.BGA_sizeFx^0.9;
					end;
					
					if g_currentMission:getIsServer() then
						g_currentMission:addSharedMoney(-costStartup, "propertyMaintenance");   --startup					
						if needBuy then
							g_currentMission:addSharedMoney(-costStartupBuy + costStartup, "constructionCost");   --startup					
						end;
					end;
					--Bga.Scan(bga) --DEBUG
					--scanTable( "self", bga, 5 )
				end;
			else
				if needBuy then
					g_currentMission:addExtraPrintText(string.format(g_i18n:getText("complexBGA_noMoney"),g_i18n:formatMoney(costStartupBuy)))
				else
					g_currentMission:addExtraPrintText(string.format(g_i18n:getText("complexBGA_noMoney"),g_i18n:formatMoney(costStartup)))
				end;
			end;
		end;
	end;
	if not g_currentMission:getIsServer() and g_currentMission.isMasterUser then

		local buy = InputBinding.hasEvent(InputBinding.BGAextension_startup);
		local feedUp = InputBinding.hasEvent(InputBinding.BGAextension_feedUp);
		local feedDown = InputBinding.hasEvent(InputBinding.BGAextension_feedDown);
		
		if buy or feedUp or feedDown then
			BGAinputEvent.sendEvent(bga,buy,feedUp,feedDown)
		end;
		
	end;
end;







BGAsyncEvent = {};
BGAsyncEvent_mt = Class(BGAsyncEvent, Event);

InitEventClass(BGAsyncEvent, "BGAsyncEvent");

function BGAsyncEvent:emptyNew()
    local self = Event:new(BGAsyncEvent_mt);
    self.className="BGAsyncEvent";
    return self;
end;

function BGAsyncEvent:new(bga)
    local self = BGAsyncEvent:emptyNew()
    self.bga = bga;
	self.fermenterTS = bga.fermenterTS;
	self.fermenter_quality = bga.fermenter_quality;
	self.fermenter_speedFx = bga.fermenter_speedFx;
	self.bunker_TS = bga.bunker_TS;
	self.bunker_quality = bga.bunker_quality;	
	self.bunker_speed = bga.bunker_speed;
	self.bunkerFeedFactor = bga.bunkerFeedFactor;
	self.fermenter_bioOK = bga.fermenter_bioOK;
	self.printPower = bga.printPower;
	self.BGA_Bonus = bga.BGA_Bonus;
	self.BGA_sizeFx = bga.BGA_sizeFx
    return self;
end;

function BGAsyncEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.bga));
	streamWriteFloat32(streamId, self.fermenterTS);
	streamWriteFloat32(streamId, self.fermenter_quality);
	streamWriteFloat32(streamId, self.fermenter_speedFx);
	streamWriteFloat32(streamId, self.bunker_TS);
	streamWriteFloat32(streamId, self.bunker_quality);
	streamWriteFloat32(streamId, self.bunkerFeedFactor);
	streamWriteBool(streamId, self.fermenter_bioOK);	
	streamWriteFloat32(streamId, self.printPower);
	streamWriteFloat32(streamId, self.BGA_Bonus);
	streamWriteFloat32(streamId, self.BGA_sizeFx);
	
	--print("server side event is sending stuff")
end;

function BGAsyncEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    self.bga = networkGetObject(id);
	
	self.bga.fermenterTS = streamReadFloat32(streamId);
	self.bga.fermenter_quality = streamReadFloat32(streamId);
	self.bga.fermenter_speedFx = streamReadFloat32(streamId);
	self.bga.bunker_TS = streamReadFloat32(streamId);
	self.bga.bunker_quality = streamReadFloat32(streamId);
	self.bga.bunkerFeedFactor = streamReadFloat32(streamId);
	self.bga.fermenter_bioOK = streamReadBool(streamId);
	self.bga.printPower = streamReadFloat32(streamId);	
	self.bga.BGA_Bonus = streamReadFloat32(streamId);	
	self.bga.BGA_sizeFx = streamReadFloat32(streamId);	
end;

function BGAsyncEvent.sendEvent(bga)
	if g_server ~= nil then
		g_server:broadcastEvent(BGAsyncEvent:new(bga), nil, nil, bga);	
	end;
end;


BGAinputEvent = {};
BGAinputEvent_mt = Class(BGAinputEvent, Event);

InitEventClass(BGAinputEvent, "BGAinputEvent");

function BGAinputEvent:emptyNew()
    local self = Event:new(BGAinputEvent_mt);
    self.className="BGAinputEvent";
    return self;
end;

function BGAinputEvent:new(bga,buy,feedUp,feedDown)
    local self = BGAinputEvent:emptyNew()
    self.bga = bga;
	self.buy = buy;
	self.feedUp = feedUp;
	self.feedDown = feedDown;
	
    return self;
end;

function BGAinputEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.bga));
	streamWriteBool(streamId, self.buy);
	streamWriteBool(streamId, self.feedUp);
	streamWriteBool(streamId, self.feedDown);	
end;

function BGAinputEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
    local bga = networkGetObject(id);
	
	local buy = streamReadBool(streamId);
	local feedUp = streamReadBool(streamId);
	local feedDown = streamReadBool(streamId);
	
	if bga.fermenter_bioOK then
		if feedUp then
			bga.bunkerFeedFactor = math.min(bga.bunkerFeedFactor + 0.05,1.5);
		end;
		if feedDown then					
			bga.bunkerFeedFactor = math.max(bga.bunkerFeedFactor - 0.05,0.5);
		end;
	else	
		--factor up/down
		if feedUp then
			bga.BGA_sizeFx = math.min(bga.BGA_sizeFx + 0.05,3);
		end;
		if feedDown then					
			bga.BGA_sizeFx = math.max(bga.BGA_sizeFx - 0.05,0.5);
		end;		
		
		if buy then
			local needBuy = bga.fermenterTS == 0;
		
			local costStartup = 120000*math.sqrt(bga.BGA_sizeFx);
			if bga.BGA_sizeFx > 1.0 then
				costStartup = costStartup + 150000;
			end;
			local costStartupBuy = 2*costStartup*bga.BGA_sizeFx^0.4;
			
			if not needBuy and g_currentMission.missionStats.money >= costStartup or g_currentMission.missionStats.money >= costStartupBuy then
				bga.fermenterTS = 0.075; 
				bga.fermenter_quality = 95/0.28;
				bga.fermenter_speedFx = 0.9;
				bga.fermenter_bioOK = true;
				bga.fermenterCapacity = 1000*1250*bga.BGA_sizeFx;
				bga.bunkerUseSpeed = 4.75*bga.BGA_sizeFx;
				bga.bunkerCapacity = 30000*bga.BGA_sizeFx^0.8;
				-- bga.BGA_Bonus_Capacity = 3*120 * g_liquidManureLitersPerAnimalPerDay["cow"]*bga.BGA_sizeFx;
				bga.BGA_Bonus_Capacity = 3 * 120 * 250 * bga.BGA_sizeFx;
				Bga.resetBunkerY(bga);
				--bga.bunkerCapacity = math.max(bga.bunkerCapacity,50000 * bga.BGA_sizeFx^0.8);
				if bga.digestateSiloTrigger~= nil then
					bga.digestateSiloTrigger.capacity = 800000* bga.BGA_sizeFx^0.9;
				end;
				
				g_currentMission:addSharedMoney(-costStartup, "propertyMaintenance");   --startup					
				if needBuy then
					g_currentMission:addSharedMoney(-costStartupBuy + costStartup, "constructionCost");   --startup					
				end;
			end;
		end;
	end;
	BGAsyncEvent.sendEvent(bga) --new in V3.01
end;

function BGAinputEvent.sendEvent(bga,buy,feedUp,feedDown)
	if g_server ~= nil then		
	else
		g_client:getServerConnection():sendEvent(BGAinputEvent:new(bga, buy,feedUp,feedDown));		
	end;
end;